#include <stdio.h>

struct int_or_double {
  enum { INT, DOUBLE } tag;   // mark which case I'm in
  union {
    int i;
    double d;
  } data;
};

typedef struct int_or_double int_or_double;

void set_int(int_or_double *e, int i)
{
  e->tag = INT;
  e->data.i = i;
}

void set_double(int_or_double *e, double d)
{
  e->tag = DOUBLE;
  e->data.d = d;
}

void print(const int_or_double *e)
{
  switch (e->tag) {
  case INT:
    printf("%d\n", e->data.i);
    break;
  case DOUBLE:
    printf("%f\n", e->data.d);
    break;
  default:
    printf("should not happen\n");
  }
}

int main(void)
{
  int_or_double a[10];
  // Now I have an array in which some elements are int, others are double!

  set_int(a+0, 45);
  print(a+0);
  set_double(a+1, 3.14);
  print(a+1);
  return 0;
}

